import { Cleanable } from '../types';
import { Runnable } from './types';
export declare class CanceledError extends Error {
    name: string;
    constructor(message?: string);
}
export interface CancellablePromiseLike<T> extends PromiseLike<T> {
    cancel(): void;
}
export declare class CancellablePromise<T> extends Promise<T> implements Runnable<T> {
    readonly cancel: () => void;
    constructor(executor: (resolve: (value: T | PromiseLike<T>) => void, reject: (reason?: any) => void) => Cleanable);
    [Symbol.iterator](): Generator<this, T, T>;
}
