import { EventStream } from '../stream';
import { Action, Cleanable } from '../types';
export declare type TaskYieldable<T> = PromiseLike<T> | ((resolve: Action<T>, reject: Action<any>) => Cleanable) | EventStream<T>;
export declare type Runnable<T> = {
    /**
     * It could be eager or lazy.
     */
    [Symbol.iterator](): RunnableGenerator<T>;
};
export declare type RunnableGenerator<T> = Generator<TaskYieldable<any>, T, any>;
export interface ReadableChannel<T> {
    next(): Runnable<T>;
    hasNext(): Runnable<boolean>;
}
export interface WriteableChannel<T> {
}
