import { Cell, WatchOptions } from './cell';
import { EventStream } from './stream';
import { Cleanable } from './types';
export declare function isCell<T>(value: unknown): value is Cell<T>;
export declare function isEventStream<T>(value: unknown): value is EventStream<T>;
export declare function action<Fn extends (...args: any[]) => any>(fn: Fn): (...args: Parameters<Fn>) => ReturnType<Fn>;
export declare function watch<T>(cell: Cell<T>, sideEffect: (value: T) => Cleanable, options?: WatchOptions): void;
export declare function listen<T>(stream: EventStream<T>, handler: (payload: T) => Cleanable): void;
export declare function autorun(sideEffect: () => Cleanable): void;
export * from './cell';
export { mutable as mut } from './cell';
export { EventStream, stream, never, merged } from './stream';
export { inject, provide, mount, mount as effect, Scope, Token } from './scope';
export type { Factory } from './scope';
export { held, reduced } from './derived';
export * from './read';
export * from './schedule';
export * from './concurrency';
export * from './reference';
export * from './debug';
