import { Cleanable } from './types';
declare type OnMountLogic = () => Cleanable;
/**
 * The dirtiest part of kairo (the second is concurrency...)
 * The bloomfilter process is inspired by Angular.
 */
declare class Scope {
    readonly parentScope?: Scope | undefined;
    readonly rootScope?: Scope | undefined;
    private onmountLogics;
    private injections;
    private injections_bloom;
    constructor(parentScope?: Scope | undefined, rootScope?: Scope | undefined);
    beginScope(): () => void;
    private static _currentScope;
    static get current(): Scope;
    registerOnMountLogic(logic: OnMountLogic): void;
    registerProvider(arg0: any, arg1?: any, ...args: any[]): any;
    inject(token: {
        name: string;
    }, options?: any): any;
    private attached;
    attach(): () => void;
}
declare function mount(onmount: OnMountLogic): void;
declare class Token<T> {
    readonly name: string;
    constructor(name: string);
    static for<T>(name: string): Token<T>;
    toString(): string;
}
interface Factory<T> {
    name: string;
    (...args: any[]): T;
}
declare function provide<T>(factory: Factory<T>, ...args: Parameters<Factory<T>>): T;
declare function provide<T>(provide: Token<T>, value: T): T;
declare function inject<T>(fn: Factory<T>, options?: {
    optional?: boolean;
    skipSelf?: boolean;
}): T;
declare function inject<T>(token: Token<T>, options?: {
    optional?: true;
    skipSelf?: boolean;
    defaultValue: T;
}): T;
declare function inject<T>(token: Token<T>, options?: {
    optional?: boolean;
    skipSelf?: boolean;
}): T;
export { inject, provide, mount, Token, Scope, Factory };
